package com.buglabs.dragonfly.cdt.poky.ui.action;

import java.io.IOException;

import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.jface.action.Action;

import com.buglabs.dragonfly.cdt.poky.ui.PokyActivator;
import com.buglabs.dragonfly.cdt.poky.ui.utils.SCP;
import com.jcraft.jsch.JSchException;

public class ExportExecutableAction extends Action {

	private IProject project;

	public ExportExecutableAction(IProject project) {
		this.project = project;
	}

	public void run() {
		Job job = new SCPJob("Sending files to QEMU");
		job.schedule();
	}

	private class SCPJob extends Job{

		public SCPJob(String name) {
			super(name);
		}

		protected IStatus run(IProgressMonitor monitor) {
			IStatus result = new Status(IStatus.OK, PokyActivator.PLUGIN_ID, IStatus.OK, "", null);

			IFolder folder = project.getFolder(".deploy");
			IPath file = folder.getFile(project.getName()).getLocation();

			SCP scp;
			try {
				scp = new SCP(file.toOSString(),PokyActivator.QEMU_HOST_DIR,PokyActivator.QEMU_USER_NAME,PokyActivator.QEMU_HOST_NAME,PokyActivator.getDefault().getQEMUPassword());
				scp.copyFile();
			} catch (JSchException e) {
				return new Status(IStatus.ERROR, PokyActivator.PLUGIN_ID, 0, "Error while sending file to QEMU", e); //$NON-NLS-1$
			} catch (IOException e) {
				return new Status(IStatus.ERROR, PokyActivator.PLUGIN_ID, 0, "Error while sending file to QEMU", e); //$NON-NLS-1$
			}
			return result;
		}
	}
}
