package com.buglabs.dragonfly.cdt.poky.ui.action;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.DebugEvent;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.IDebugEventSetListener;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.debug.core.model.RuntimeProcess;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import com.buglabs.dragonfly.cdt.poky.ui.launch.PokyLaunchShortcut;

public class LaunchPokyAction implements IWorkbenchWindowActionDelegate, IDebugEventSetListener{
	
	private IAction action;
	private static final String TYPE = "type";
	private static final String POKY = "POKY";

	public void init(IWorkbenchWindow window) {
		DebugPlugin.getDefault().addDebugEventListener(this);
	}
	public void run(final IAction action) {
		try {
			this.action = action;
			
			PokyLaunchShortcut launchSC = new PokyLaunchShortcut();
			ILaunch launch = launchSC.launch(ILaunchManager.DEBUG_MODE);
			
		/*	IProcess[] launchedProcesses = launch.getProcesses();
			launchedProcesses[0].setAttribute(TYPE,VIRTUAL_BUG);
			
			// disable launch button only if processes were started
			if(launchedProcesses.length != 0)
				action.setEnabled(false);

			// we need to find out when virtual bug has launched so we can
			// enabled vb button, once we enable
			// and user tries to launch again, connecting to ServerSocket will
			// throw an exception.
			if(launchedProcesses != null && launchedProcesses.length > 0) {
				launchedProcesses[0].getStreamsProxy().getOutputStreamMonitor().addListener(new IStreamListener() {
					int cnt = 0;

					public void streamAppended(String text, IStreamMonitor monitor) {
						if (text.indexOf("com.buglabs.bug.emulator.awt") != -1) {
							cnt++;
							if (cnt == 2){
								action.setEnabled(true);
							}
						}
					}

				});
			}*/
		} catch (CoreException e) {
			action.setEnabled(true);
			//UIUtils.handleVisualError("Unable to launch Virtual BUG", e);
		}
		catch(Exception e){
			action.setEnabled(true);
			//UIUtils.handleNonvisualError("Unable to launch Virtual BUG", e);
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		// TODO Auto-generated method stub

	}
	
	public void dispose() {
		// TODO Auto-generated method stub

	}

	public void handleDebugEvents(DebugEvent[] events) {
		for(int i = 0; i < events.length; i++){
			if(events[i].getKind() == DebugEvent.TERMINATE){
				if(events[i].getSource() instanceof RuntimeProcess){
					RuntimeProcess rp = (RuntimeProcess) events[i].getSource();
					String type = rp.getAttribute(TYPE);
					if(type != null){
						if(type.equals(POKY)){
							if(!action.isEnabled()){
								action.setEnabled(true);
							}
						}
					}
				}
			}
		}
	}
}
