package com.buglabs.dragonfly.cdt.poky.ui.launch;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class PasswordDialog extends Dialog {

	private String pwd;

	private boolean saveAuthData = false;

	private Button btnSaveAuth;

	private String message;

	public static final int ACCOUNT_CREATE_ID = Integer.MAX_VALUE - 1;

	public PasswordDialog(Shell topShell, String message) {
		super(topShell);
		this.message = message;
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Password"); //$NON-NLS-1$
	}

	protected Control createDialogArea(Composite parent) {

		Composite top = new Composite(parent, SWT.NONE);
		GridData gdSpanAll = GridDataFactory.fillDefaults().create();
		gdSpanAll.horizontalSpan = 2;
		GridData gdFillH = GridDataFactory.fillDefaults().create();

		gdFillH.widthHint = 150;
		GridLayout layout = new GridLayout(2, false);
		top.setLayout(layout);

		Label lbl = new Label(top, SWT.NONE);
		lbl.setText(message); //$NON-NLS-1$
		lbl.setLayoutData(gdSpanAll);
		
		Label lblPassword = new Label(top, SWT.NONE);
		lblPassword.setText("password"); //$NON-NLS-1$
		Text txtPassword = new Text(top, SWT.BORDER);
		txtPassword.setLayoutData(gdFillH);
		txtPassword.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				pwd = ((Text) e.widget).getText();
			}
		});

		createSpacer(top);

		btnSaveAuth = new Button(top, SWT.CHECK);
		btnSaveAuth.setText("save"); //$NON-NLS-1$
		btnSaveAuth.addSelectionListener(new SelectionListener() {

			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub

			}

			public void widgetSelected(SelectionEvent e) {
				saveAuthData = ((Button) e.widget).getSelection();
			}

		});

		createSpacer(top);

		return top;
	}

	private void createSpacer(Composite top) {
		Layout layout = top.getLayout();
		if (layout instanceof GridLayout) {
			int columns = ((GridLayout) layout).numColumns;
			Label spacer = new Label(top, SWT.NONE);
			GridData gd = new GridData();
			gd.heightHint = 5;
			gd.horizontalSpan = columns;
			spacer.setLayoutData(gd);
		}
	}

	public boolean getSaveAuthentication() {
		return saveAuthData;
	}

	public String getPwd() {
		if (pwd == null) {
			pwd = "";
		}

		return pwd;
	}

	public void setPwd(String pwd) {
		this.pwd = pwd;
	}
}
