package com.buglabs.dragonfly.cdt.poky.ui.launch;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.model.ILaunchConfigurationDelegate;
import org.eclipse.debug.core.model.LaunchConfigurationDelegate;

import com.buglabs.dragonfly.cdt.poky.ui.utils.UIUtils;

/**
 * Poky launch configuration
 * 
 * @author akravets
 * 
 */
public class PokyLaunchConfigurationDelegate extends LaunchConfigurationDelegate implements ILaunchConfigurationDelegate {
	public static final String ID = "com.buglabs.dragonfly.cdt.poky.ui.launch.delegate";
	public static final String COMPILER = "COMPILER";
	public static final String KERNEL = "KERNEL";
	public static final String ROOTFS = "ROOTFS";
	public static final String PROPERTIES = "PROPERTIES";

	private static final String POKY_QEMU = "poky-qemu";
	
	private ShellHelper shell;

	public PokyLaunchConfigurationDelegate() {
		shell = new ShellHelper();
	}
	
	public void launch(ILaunchConfiguration configuration, String mode, ILaunch launch, IProgressMonitor monitor) throws CoreException {
		Map props = configuration.getAttribute(PokyLaunchConfigurationDelegate.PROPERTIES, new HashMap());
		String kernel = (String) props.get(PokyLaunchConfigurationDelegate.KERNEL);
		String rootfs = (String) props.get(PokyLaunchConfigurationDelegate.ROOTFS);
		final String command = POKY_QEMU + " " + kernel + " " + rootfs;
		
		try {
			Runtime.getRuntime().exec("sudo -k");
			shell.sudoExecute(command, "", "");
		} catch (Exception e) {
			UIUtils.handleVisualError("Unable to launch QEMU", e);
		}
	}
}