package com.buglabs.dragonfly.cdt.poky.ui.utils;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import com.buglabs.dragonfly.cdt.poky.ui.PokyActivator;

public class UIUtils {
	/**
	 * Logs an error to the Eclipse error log and displays message in dialog
	 * box.
	 * 
	 * @param message
	 * @param e
	 */
	public static void handleVisualError(String message, Exception e) {
		PokyActivator.getDefault().logError(message, e);
		final Display disp = PlatformUI.getWorkbench().getDisplay();
		final String msg = message;

		disp.syncExec(new Runnable() {
			public void run() {
				MessageDialog.openError(new Shell(disp), "An error has occurred.", msg
						+ "\n\nPlease consult log file for additional details.");
			}
		});
	}
}
